//////////////////////////////////////////////////////////////////////

#include "glwindows.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GLWindows::GLWindows()
{
  
 #ifdef USEGLUT
  printf ("Utilisation sous GLUT\n");
 #else
    #ifdef XWINDOW
      printf ("Utilisation sous XWINDOW\n");
    #else
      printf ("Utilisation sous MS WINDOWS\n");      
    #endif
 #endif
 
 #ifndef USEGLUT  // Glut est utilisable aussi sous Windows. Dans ce cas, il ne faut pas faire le traitement qui suit, GLUT prend tout en charge
   #ifdef _WIN32
  // Création d'une classe de fenêtre pour Windows
	WNDCLASS	wndclassex;				// Classe de notre windows

	hInstance = NULL;
	hWnd = NULL;
	hRC = NULL;
	hDC = NULL;
	fullscreen = false;
	bDestroy = false;
	long lInstance;
	
	lInstance =  reinterpret_cast <long> ( this );
	sprintf (cClasse, "OpenGL - %d", lInstance);

	if (hInstance == 0) // Si pas d'instance de programme, nous en d�clarons une !
		hInstance			= GetModuleHandle(NULL);
	
	wndclassex.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC | CS_DBLCLKS;
	wndclassex.lpfnWndProc		= WndProcGLW;
	wndclassex.cbClsExtra		= 0;
	wndclassex.cbWndExtra		= 0;
	wndclassex.hInstance		= hInstance;
	wndclassex.hIcon			= LoadIcon(NULL, IDI_WINLOGO);
	wndclassex.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wndclassex.hbrBackground	= NULL;
	wndclassex.lpszMenuName		= NULL;
	wndclassex.lpszClassName	= cClasse;

	if (!RegisterClass(&wndclassex)) // Enregistrons notre classe !
	{
		MessageBox(NULL,"Echec lors de l'enregistrement de la classe de notre fen�tre.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		bQuit = true;
	}
	else
		bQuit = false;
  #else
  // XWindow
  	hWnd = NULL;
	hRC = NULL;
	hDC = NULL;
	fullscreen = false;
	bDestroy = false;
	bQuit = false;
  #endif
#else
// Initialisation de GLUT
// Simulation des argc et argv
int argcv = 1; // Nombre de paramètres. Minimum à 1 qui correspond au paramètre indiquant le nom de la commande
char *argvv[2]; // Pointeur sur des char contenant les paramètres
char commande [] = "GLUT"; // Le premier est la commande (nom du programme). Les suivants devraient être des arguments, mais ici on s'en fiche...

  bQuit = false;
  hWnd = NULL;
  fullscreen = false;
  bDestroy = false;

  // Construction d'un pseudo tableau de paramètres
  argvv[0] = &commande[0]; // Commande, il est obligatoire ce paramètre
  argvv[1] = 0; // Fin de la liste des paramètres

  // Et on passe le tout à glut init
  glutInit (&argcv, argvv);

  // initialisation des pointeurs
  glliste = GLListe::getInstance ();

#endif
	bCamdebug = false;
	Cam.SetPasMax (10.f, 10.f, 10.f, 10.f); // Initialisation des pas max de la cam�ra
	// Les coordonnées centrales de la fenetre / ecran ne sont pas encore connues
	PosCenter.x = -1;
	PosCenter.y = -1;
}

GLWindows::~GLWindows()
{
#ifndef USEGLUT
	if (hWnd)
		this->onDestroyGLW();
#endif
	destroyWindowGLW();


#ifdef USEGLUT
	glliste->kill();
#endif
	
#ifndef USEGLUT
  #ifdef _WIN32
	if (hInstance)
		UnregisterClass(cClasse,hInstance);	// Destruction de notre classe de fen�tre Windows
  #endif
#endif
}

#ifndef USEGLUT

HDC GLWindows::getDCGLW(void) // Retourne DC
{
	return hDC;
}


HGLRC GLWindows::getRCGLW(void) // Retourne RC
{
	return hRC;
}
  #ifndef _WIN32
  
Display* GLWindows::getDisplayGLW(void)
{
      return dpy;
}
  #endif
#endif

void GLWindows::SwapBuffersGLW(void)
{
	  #ifdef USEGLUT
	    glutSwapBuffers();
	  #else
	    #ifdef _WIN32
	      SwapBuffers( getDCGLW () );
	    #else
	      glXSwapBuffers ( dpy, win );
	    #endif
	  #endif
}

#ifdef USEGLUT
HWNDGLUT GLWindows::getHWNDGLW()
#else
#ifdef _WIN32
HWND GLWindows::getHWNDGLW() // Retourne HWnd
#else
Window GLWindows::getHWNDGLW() // Retourne HWnd
#endif
#endif
{
	return hWnd;
}

// Procédure de gestion des messages vraiment spécifiques à Windows !
#ifndef USEGLUT
#ifdef _WIN32
LRESULT CALLBACK	GLWindows::WndProcGLW(HWND hWnd, UINT message, UINT wParam, LONG lParam)
{

	GLWindows* hGLWindow;
	LRESULT result = FALSE;
	long hInstGL;


    if (message == WM_NCCREATE) // On ne peut rien faire ici, en cours de cr�ation !
		return DefWindowProc (hWnd, message, wParam, lParam);

    if (message == WM_CREATE)
    {
		// R�cup�ration de l'instance GLWindow m�moris�e dans les param�tres de notre fen�tre windows (lParam)
		hGLWindow = (GLWindows*) ((CREATESTRUCT*) lParam)->lpCreateParams;
		if (hGLWindow == NULL)
			return -1;
		// Memorisation de l'instance de notre objet GLWindow dans la fen�tre
		SetWindowLong(hWnd, GWL_USERDATA, (LONG) hGLWindow);
		// Maintenant on lance l'�vent onCreate qui est virtuel dans notre classe...
		if (!hGLWindow->onCreateGLW())
			return -1; // Echec !
		return 0; // Pas de pb.
    }

	// Ok, on peut r�cup�rer l'instance GLWindow associ�e � la fen�tre Windows en cours via GWL_USERDATA o� est m�moris�e notre instance.
    hInstGL = GetWindowLong (hWnd, GWL_USERDATA);
    hGLWindow = reinterpret_cast <GLWindows*> ( hInstGL );
    if (hGLWindow == NULL) // L�, il y a un malaise, instance non trouv�e, on ne peut donc rien lancer !
		return DefWindowProc(hWnd, message, wParam, lParam); // Laissons Windows se d�brouiller ...

    if (hGLWindow->getRCGLW() && hGLWindow->getDCGLW())
	wglMakeCurrent(hGLWindow->getDCGLW(), hGLWindow->getRCGLW());

    switch (message)
	{
		case WM_DESTROY:
		{
			hGLWindow->onDestroyGLW(); // Si vous avez des trucs � d�faire...
			hGLWindow->destroyWindowGLW();
			PostQuitMessage (0);
			return 0;
		}

		case WM_SIZE:         // Si vrai, ne change pas la taille, sinon traitement standard		
		{
			// LoWord=Width, HiWord=Height
			POINT PosCenter;
			PosCenter.x = LOWORD(lParam) / 2; // On calcule la nouvelle position du centre de la fen�tre
			PosCenter.y = HIWORD(lParam) / 2;

			hGLWindow->setCenterScreenGLW (PosCenter.x, PosCenter.y);
			hGLWindow->reSizeSceneGLW(LOWORD(lParam),HIWORD(lParam)); // Informer OpenGL du changement de taille
			if (hGLWindow->onSizeGLW((long) wParam, LOWORD(lParam), HIWORD(lParam))) 
				return 0;
			break;
		}

		case WM_PAINT:
			if (!hGLWindow->onPaintGLW())
				return 0;
			break;

		case WM_CLOSE:
		{
		// onClose accepte-t-il la fermeture ?
			if (!hGLWindow->onCloseGLW()) // Non, alors ne pas continuer !
				return 0;
			break; // Oui, laissons windows g�rer cela, il renverra un WM_DESTROY o� nous fermerons toutes les ressources de notre classe
		}

		case WM_COMMAND:
			if (hGLWindow->onCommandGLW(HIWORD(wParam), (HWND) lParam, LOWORD(wParam)))
				return 0;
			break;

		case WM_KILLFOCUS:
		case WM_ACTIVATEAPP: // Touche Alt-Tab ou click sur une autre appli
			// On refuse le ALT-TAB
			return 0;

		case WM_KEYDOWN: // Touche press�e
		{
			if (hGLWindow->onKeyDownGLW (wParam))
				return 0;
			break;
		}

		case WM_KEYUP: // Touche relach�e
		{
			if (hGLWindow->onKeyUpGLW (wParam))
				return 0;
			break;
		}

		case WM_MOUSEMOVE:
		case WM_NCMOUSEMOVE:
			// Je n'utilise pas les positions pass�es en param�tre, mais vais les relire.
			POINT pointSouris;
			POINT pointScrSouris;
			GetCursorPos (&pointScrSouris);
			pointSouris.x = pointScrSouris.x;
			pointSouris.y = pointScrSouris.y;
			ScreenToClient (hWnd, &pointSouris);
			if (hGLWindow->onPosMouseGLW (pointScrSouris, pointSouris))
				return 0;
			break;

		// Clique sur bouton gauche
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
		case WM_LBUTTONDBLCLK:
		// De m�me, pour le bouton du milieu:
		case WM_MBUTTONDOWN:
		case WM_MBUTTONUP:
		case WM_MBUTTONDBLCLK:
		// Et enfin le bouton droit:
		case WM_RBUTTONDOWN:
		case WM_RBUTTONUP:
		case WM_RBUTTONDBLCLK:
			if (hGLWindow->onClickMouseGLW (message))
				return 0;
			break;



		case WM_SYSCOMMAND:
		{
			switch (wParam)
			{
				case SC_SCREENSAVE:
				case SC_MONITORPOWER:
				return 0;
			}
			break;
		}

		case WM_ERASEBKGND: // Ne rien faire !
			return 0;

		default:
		// virtual message handling
			if (hGLWindow->onEventGLW(message, wParam, lParam, result))
				return result;
	}
	// default msg handling
	return DefWindowProc(hWnd, message, wParam, lParam);
}
#else
// Procedure de gestion des messages sous XWindow
int	GLWindows::WndProcGLW(XEvent event)
{ 
  
// Pour gestion du clavier
int count;
int buffer_size = 80;
char buffer[80];
KeySym keysym;
XComposeStatus       status_in_out ;

    if (getRCGLW() && getDCGLW())
      glXMakeCurrent(getDisplayGLW(), getDCGLW(), getRCGLW());

    switch  (event.type)
    {
      case ClientMessage:
	      if (event.xclient.data.l[0] == wmDeleteMessage)
	      {
		printf ("Fin du programme demande !!!\n");
		if (!onCloseGLW()) // Non, alors ne pas continuer !
		{
		  printf ("Demande refusee\n");
		  return 0;
		}
		else
		{
		  printf ("Fin du programme lance\n");
		  // Oui, laissons windows g�rer cela, il renverra un WM_DESTROY o� nous fermerons toutes les ressources de notre classe
		  onDestroyGLW(); // Si vous avez des trucs � d�faire...
		  destroyWindowGLW();
		}
	      }
      break;
      
      case Expose:   
	if (event.xexpose.count == 0) // On ne fera que le dernier event expose (si plusieurs cumulés)
	  if (! onPaintGLW())
	    return 0;
      break;
  
      case ConfigureNotify:
	    if (event.xconfigure.width != iWinWidth ||
		event.xconfigure.height != iWinHeight || 
		PosCenter.x == -1 || PosCenter.y == -1)
	    {
	      POINT PosCenter ;
	      PosCenter.x = event.xconfigure.width / 2; // On calcule la nouvelle position du centre de la fen�tre
	      PosCenter.y = event.xconfigure.height / 2; 
	    
	      Window win_null_return;
	      
	      setCenterScreenGLW (PosCenter.x, PosCenter.y);
	      
	      reSizeSceneGLW((GLsizei) event.xconfigure.width, (GLsizei) event.xconfigure.height); // Informer OpenGL du changement de taille
	      if (onSizeGLW((long) 0, event.xconfigure.width, event.xconfigure.height)) 
		return 0;
	    }
	break;
		    
      case KeyPress:
	  count = XLookupString((XKeyEvent*)&event,buffer,buffer_size, &keysym,&status_in_out);
	  // if (count >0 ) - ATTENTION - Cas des touches Fn qui n'ont pas de code ASCII
	    onKeyDownGLW (keysym);
      break;

      case KeyRelease:
	  count = XLookupString((XKeyEvent*)&event,buffer,buffer_size, &keysym,&status_in_out);
	  // if (count >0 ) - ATTENTION - Cas des touches Fn qui n'ont pas de code ASCII
	    onKeyUpGLW (keysym);
      break;

      /* D�placement du pointeur */
      case MotionNotify:
/*	if (!bignoreMotionnotify)
	{*/
	  POINT pointSouris;
	  POINT pointScrSouris;

	  Window win_null_return;

	  unsigned int state ;
	  // XQueryPointer pour r�cup�rer les infos de la souris sur la root window ! car l'evenement onPosMouseGLW passe les coordonnées / à la fenetre et / à l'ecran

	  // Convertir les coordonnées centrales en coordonnes relatives à la root window
	  pointSouris.x = event.xmotion.x;
	  pointSouris.y = event.xmotion.y;
	  XTranslateCoordinates (dpy, getHWNDGLW(), DefaultRootWindow(dpy), pointSouris.x, pointSouris.y, &pointScrSouris.x, &pointScrSouris.y, &win_null_return);
//	  
//	  printf ("Coord.: %d, %d - %d, %d \n", pointScrSouris.x, pointScrSouris.y, pointSouris.x, pointSouris.y);	  
	  
	  if (onPosMouseGLW (pointScrSouris, pointSouris))
	      return 0;
/*	}
	else
	  bignoreMotionnotify = false;*/
      break;

      default:
	return onEventGLW(event);
    }
  
}
#endif
#endif


#ifdef USEGLUT
void GLWindows::GLUTaffichage(void)
{
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;
  
  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );
  hGLWindow->onPaintGLW();
}

void GLWindows::GLUTIdle(void)
{
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;
  
  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );
  hGLWindow->onIdleGLW();
}

void GLWindows::GLUTKeyboard(unsigned char key, int x, int y)
{
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;
  
  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );
//  printf ("Key !\n");
  hGLWindow->onKeyDownGLW((WPARAM) key);
}

void GLWindows::GLUTSpecialKey(int key, int x, int y)
{
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;
  
  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );
//  printf ("Special Key !\n");
  hGLWindow->onKeyDownGLW((WPARAM) key);
}

void GLWindows::GLUTMotionMouse(int x, int y)
{
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;
  POINT xySrc;
  POINT xyClt;
  
  xyClt.x = x;
  xyClt.y = y;

  #ifdef _WIN32
	GetCursorPos(&xySrc);
  #else
    Display*       dpy;
    Window  root_return, child_return;
    int win_x, win_y;
    unsigned int              state ;
    Window              root;
    dpy   = XOpenDisplay (NULL);

    if (dpy != NULL)
    {
	/* R�cup�ration du handle de la fen�tre principale */
       root = DefaultRootWindow (dpy);
       // XQueryPointer pour r�cup�rer les infos de la souris sur la root window ! car l'evenement onPosMouseGLW passe les coordonnées / à la fenetre et / à l'ecran
       XQueryPointer ( dpy,  root, &root_return, &child_return, &xySrc.x, &xySrc.y, &win_x, &win_y, &state);

       XCloseDisplay(dpy);
    }
  #endif

  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );
  hGLWindow->onPosMouseGLW(xySrc, xyClt);
}

void GLWindows::GLUTPassiveMotionMouse(int x, int y)
{
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;
  POINT xySrc;
  POINT xyClt;
  
  xyClt.x = x;
  xyClt.y = y;

  #ifdef _WIN32
	GetCursorPos(&xySrc);
  #else
	Display*       dpy;
	Window              root;
	Window  root_return, child_return;
	int win_x, win_y;
	unsigned int state ;
	dpy   = XOpenDisplay (NULL);

	if (dpy != NULL)
	{
	  root = DefaultRootWindow (dpy);
	// XQueryPointer � priori pour r�cup�rer les infos de la souris sur la root window !
	  XQueryPointer ( dpy,  root, &root_return, &child_return, &xySrc.x, &xySrc.y, &win_x, &win_y, &state);
	  XCloseDisplay(dpy);
	}
	
	
  #endif

  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );
  hGLWindow->onPosMouseGLW(xySrc, xyClt);
}

void GLWindows::GLUTSize (int width, int height)
{
  
  GLWindows *hGLWindow;
  GLListe *glliste;
  long instance;

  glliste = GLListe::getInstance ();
  glliste->LireElement (glutGetWindow(), instance);
  hGLWindow = reinterpret_cast <GLWindows*> ( instance );

	POINT PosCenter;
	
	PosCenter.x = (width / 2);
	PosCenter.y = (height / 2);
	hGLWindow->setCenterScreenGLW (PosCenter.x, PosCenter.y);
	hGLWindow->reSizeSceneGLW(width, height); // Informer OpenGL du changement de taille
	hGLWindow->onSizeGLW((long) 0, width, height);

}
#endif
	//********************************************************//
	//**** Cr�ation d'une fen�tre tout simplement         ****//
	//********************************************************//
BOOL GLWindows::createWinExGLW(char* title, int x, int y, int width, int height, int bits, bool fullscreenflag)
{
#ifdef USEGLUT
	glutInitWindowSize (width, height);
	glutInitWindowPosition (x, y);
	glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	hWnd=glutCreateWindow (title);
	glutDisplayFunc (GLUTaffichage);
	glutIdleFunc (GLUTIdle);
	glutReshapeWindow (width,height ); // Déja fait avant la creation, pour être certain que le système prend en compte notre taille
	glutKeyboardFunc (GLUTKeyboard);
	glutSpecialFunc (GLUTSpecialKey);
	glutMotionFunc (GLUTMotionMouse);
	glutPassiveMotionFunc (GLUTPassiveMotionMouse);
	glutReshapeFunc (GLUTSize);
	fullscreen=fullscreenflag;			// Memorisation de l'option fullscreen passee en parametre
	glutSetWindow(hWnd);	// Indique que notre nouvelle fenêtre est la fenêtre courante pour les prochaine commande GLUT n'utilisant pas le handle
	glliste->AjouteListe(hWnd, reinterpret_cast <long> ( this ));
	if (fullscreen)
	{
		CartGraph = new cartGraph (width, height, bits, 0);
		
		if (!CartGraph->GetEtatInit())
		{
			fullscreen=FALSE;		// Fullscreen impossible, passage en mode fenetre

			delete CartGraph;
			// Une application est toujours lanc�e dans une fen�tre mais bon ...
//			DebugTrace("Echec lors du passage en mode plein �cran. L'application sera lanc�e dans une fen�tre.");
		}
	}
	return TRUE;
#else
  #ifdef _WIN32
  // Code purement Windows ici...
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Utilise pour definie les coordonnees de la zone cliente



	fullscreen=fullscreenflag;			// Memorisation de l'option fullscreen passee en parametre
	
	// Si option fullscreen, modifier la resolution de l'ecran a celle passe en parametre
	if (fullscreen)
	{
		CartGraph = new cartGraph (width, height, bits, 0);
		
		if (!CartGraph->GetEtatInit())
		{
			fullscreen=FALSE;		// Fullscreen impossible, passage en mode fenetre

			delete CartGraph;
			// Une application est toujours lanc�e dans une fen�tre mais bon ...
			MessageBox(NULL,"Echec lors du passage en mode plein ecran. L'application sera lancee dans une fenetre.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		}
	}

	if (fullscreen)												
	{
		dwExStyle=WS_EX_APPWINDOW;								
		dwStyle=WS_POPUP;
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;	// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;					// Windows Style
	}

	// Apr�s avoir d�fini le style de notre fen�tre, nous allons en d�duire sa taille par rapport 
	// � la taille que l'on d�sire pour notre zone cliente c�d les valeurs re�ues dans width et height.
	WindowRect.left=0;
	WindowRect.right=(long)width;
	WindowRect.top=0;
	WindowRect.bottom=(long)height;

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);

	// Cr�ation d'une instance de fen�tre
	if (!fullscreen)
	{ // Utilisation des positions par d�faut de windows
		if (x == -1 || x == CW_USEDEFAULT)
			x = CW_USEDEFAULT;
		if (y == -1 || y == CW_USEDEFAULT)
			y = CW_USEDEFAULT;
	}
	else
	{ // Plein �cran, la fen�tre occupe donc toute l'�cran !
		x = 0;
		y = 0;
	}

	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style
								cClasse,							// Nom de notre classe
								title,								// Titre
								dwStyle |							
								WS_CLIPSIBLINGS |					
								WS_CLIPCHILDREN,					
								x, y,								// position en x, y
								WindowRect.right - WindowRect.left,	// largeur
								WindowRect.bottom - WindowRect.top,	// hauteur
								NULL,								// Pas de parent
								NULL,								// Pas de menu
								hInstance,							// Instance
								this)))								// On passe dans lParam de WM_create l'instance de notre objet GLWindow
	{
		// Creation impossible, 
		destroyWindowGLW();	// Il n'y a plus qu'� tout remettre en etat !
		MessageBox(NULL,"Erreur lors de la creation de la fenetre.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}
	return TRUE;
  #else
	if (dpy != NULL)
	{

	    swa.colormap = XCreateColormap( dpy, RootWindow( dpy, vi->screen ), vi->visual, AllocNone );
	    swa.background_pixmap = None ; // Image fond de la fenêtre
	    if (fullscreenflag)
	      swa.border_pixel      = 0; // Taille de la bordure
	    else
	      swa.border_pixel      = 1; // Taille de la bordure
	    swa.event_mask        = PointerMotionMask | ButtonPressMask | ExposureMask | KeyPressMask | KeyReleaseMask | StructureNotifyMask;  // Types Evenements pour lesquels notre programme devra être informé 

	    printf( "Création de la fenêtre...\n" );
	    win = XCreateWindow( dpy, RootWindow( dpy, vi->screen ), 0, 0, width, height, 0, vi->depth, InputOutput, vi->visual, 
					CWBorderPixel|CWColormap|CWEventMask, &swa );
	    if ( !win )
	    {
	      printf( "Echec lors de la création de la fenêtre.\n" );
	      return FALSE;
	    }

	    printf ("n°%d\n",win);
	    XStoreName( dpy, win, title); // Titre de notre fenêtre
	    XMapWindow( dpy, win ); // Affichage de la fenetre, mais elle ne s'affichera certainement pas, le window manager fait bien ce qu'il lui plait !	 
	    
	    // On demande l'interception du message delete window
	    wmDeleteMessage = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
	    XSetWMProtocols(dpy, win, &wmDeleteMessage, 1);

	}
	else
	{
		printf ("Pas de connexion au serveur X, creation d'une fenetre impossible !\n");
		return FALSE;
	}
	return TRUE;
  #endif
#endif
}

GLvoid GLWindows::reSizeSceneGLW(GLsizei width, GLsizei height)	// Changement de taille pour OpenGL
{
	if (height==0)										// Evitons la division par 0
	{
		height=1;										
	}

	iWinWidth = width;
	iWinHeight = height;
	
	glViewport(0,0,width,height);						// Viewport aux nouvelles dimensions

	glMatrixMode(GL_PROJECTION);						// Matrice en mode projection
	glLoadIdentity();									// Et on r�initilise

	// Maj de la vue en perspective
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,.5f,100000.0f);

	glMatrixMode(GL_MODELVIEW);							// Matrice en mode modelview
	glLoadIdentity();									// Et r�initialisation
	#ifdef USEGLUT
		glutPostRedisplay();
	#endif
}
 
BOOL GLWindows::openWindowGLW(char* title, int x, int y, int width, int height, int bits, bool fullscreenflag)
{
	// Cr�ation de la fen�tre
	if (!bQuit)
	{
		#ifndef XWINDOW
		
		if (createWinExGLW (title, x, y, width, height, bits, fullscreenflag))
		{
		  #ifdef USEGLUT
			glutPostRedisplay(); // Affichage de la fenêtre courante (hWnd)
			glutWarpPointer(width/2 + 1, height/2);
			initOpenGLGLW(bits);
			hideMouseGLW();
			return TRUE;
		  #else
		    #ifdef _WIN32
			// et on poistionne la souris au milieu de notre fen�tre
			SetCursorPos(width/2 + 1, height/2); // Ce qui va lancer un WM_MOUSEMOVE
			if (initOpenGLGLW(bits))
			{
				ShowWindow(hWnd,SW_SHOW);						
				SetForegroundWindow(hWnd);		// Notre fen�tre � l'avant plan
				SetFocus(hWnd);									
				reSizeSceneGLW(width, height);					
				hideMouseGLW();
				return TRUE;
			}
			else
			{
				destroyWindowGLW();
				return FALSE;
			}
		    #endif
		  #endif
		}
		else
			return FALSE;
		#else
		        // XWindow...
			if (x==CW_DEFAULT)
			    x=0;
			if (y==CW_DEFAULT)
			    y=0;
			if (width==CW_DEFAULT)
			    width=640;
			if (height==CW_DEFAULT)
			    height=480;
			 
		 	dpy   = XOpenDisplay (NULL);
			if (dpy != NULL)
			{
			  
			    XSetWindowAttributes attr;
			    XClassHint *xch;
			    MWMHints  mwmhints;
			    Atom prop = None;
/*			    attr.backing_store = NotUseful;
			    attr.override_redirect = False;
			    attr.colormap = 0;
			    attr.border_pixel = 0;
			    attr.background_pixel = 0;
			    attr.save_under = False;
			    attr.event_mask =
			      StructureNotifyMask | ButtonPressMask | ButtonReleaseMask |
			      PointerMotionMask | EnterWindowMask | LeaveWindowMask | KeyPressMask |
			      KeyReleaseMask | ButtonMotionMask | ExposureMask | FocusChangeMask |
			      PropertyChangeMask | VisibilityChangeMask;
*/
			    if (fullscreenflag)
			    {
			      prop = XInternAtom(dpy, "_MOTIF_WM_HINTS", True);
			      if (prop == None)
			      {
				printf("Window Manager ne supporte pas MWM hints. On reste en mode fenetre.");
//				attr.override_redirect = True;
//				mwmhints.flags = 0;
				fullscreen = false;
			      }
			      else
			      {
				mwmhints.flags = MWM_HINTS_DECORATIONS;
				mwmhints.decorations = 0;
			      }
			      fullscreen = true;
			    }
			    else
			    {
			      mwmhints.flags = 0;
			      fullscreen = false;
			    }			  
			  
			    // Initialisation des attributs que l'on désire pour notre affichage
			    static int visual_attribs[] =
			      {
				GLX_X_RENDERABLE    , True,
				GLX_DRAWABLE_TYPE   , GLX_WINDOW_BIT,
				GLX_RENDER_TYPE     , GLX_RGBA_BIT,
				GLX_X_VISUAL_TYPE   , GLX_TRUE_COLOR,
				GLX_RED_SIZE        , 8,
				GLX_GREEN_SIZE      , 8,
				GLX_BLUE_SIZE       , 8,
				GLX_ALPHA_SIZE      , 8,
			        GLX_DEPTH_SIZE      , 24,
			        GLX_STENCIL_SIZE    , 8,
			        GLX_DOUBLEBUFFER    , True,
				//GLX_SAMPLE_BUFFERS  , 1,
				//GLX_SAMPLES         , 4,
				None // Indique la fin de la définition des attributs
			      };
			      
			  // On passe tout de suite en fullscreen, nous en avons besoin pour initialiser comme il faut OpenGL
		 	  if (fullscreen)
			  {
				  CartGraph = new cartGraph (width, height, bits, 0);
				  
				  if (!CartGraph->GetEtatInit())
				  {
					  fullscreen=FALSE;		// Fullscreen impossible, passage en mode fenetre

					  delete CartGraph;
					  // Une application est toujours lanc�e dans une fen�tre mais bon ...
					  printf ("Echec lors du passage en mode plein ecran. L'application sera lancee dans une fenetre.\n");
				  }
			  }
			  
			  int fbConfigscount;
			  GLXFBConfig *fbConfigs = glXChooseFBConfig( dpy, DefaultScreen( dpy ), visual_attribs, &fbConfigscount );
			  if ( !fbConfigs )
			  {
			      printf( "Echec lors de la recherche d'un buffer frame ayant une configuration correspondante...\n" );
			      if (fullscreen)
				delete CartGraph;
			      XCloseDisplay(dpy); // Fin de la connexion et au revoir...
			      dpy=NULL;
			      return FALSE;
			  }
			  printf( "Nombre de configuration répondant aux critères: %d.\n", fbConfigscount );

			    // Pick the FB config/visual with the most samples per pixel
			  printf( "Lecture des configurations:\n" );
			  int best_fbConfigs = -1, worst_fbConfigs = -1, best_num_samp = -1, worst_num_samp = 999;

			  int i;
			  int samp_buf, samples;

			  for ( i = 0; i < fbConfigscount; i++ )
			  {
			      vi = glXGetVisualFromFBConfig( dpy, fbConfigs[i] );
			      if ( vi )
			      {
				glXGetFBConfigAttrib( dpy, fbConfigs[i], GLX_SAMPLE_BUFFERS, &samp_buf );
				glXGetFBConfigAttrib( dpy, fbConfigs[i], GLX_SAMPLES       , &samples  );
				
/*				printf( "  Configuration frame buffer %d, visual ID 0x%2x: SAMPLE_BUFFERS = %d, SAMPLES = %d\n", 
					i, vi->visualid, samp_buf, samples );
*/
				if ( best_fbConfigs < 0 || samp_buf && samples > best_num_samp )
				  best_fbConfigs = i, best_num_samp = samples;
				if ( worst_fbConfigs < 0 || !samp_buf || samples < worst_num_samp )
				  worst_fbConfigs = i, worst_num_samp = samples;
			      }
			      XFree( vi );
			  }
			  
			  int fbConfigs_id = best_fbConfigs;

			  vi = glXGetVisualFromFBConfig( dpy, fbConfigs[ fbConfigs_id ]  );
			  glXGetFBConfigAttrib( dpy, fbConfigs[fbConfigs_id], GLX_SAMPLE_BUFFERS, &samp_buf );
			  glXGetFBConfigAttrib( dpy, fbConfigs[fbConfigs_id], GLX_SAMPLES       , &samples  );

			  printf( "Choix: visual ID = 0x%x: SAMPLE_BUFFERS = %d, SAMPLES = %d\n", 
					i, vi->visualid, samp_buf, samples );
			  
			  if (createWinExGLW (title, x, y, width, height, bits, fullscreen))
			  {

			      if (fullscreen)
			      {
				// Le window manager fait ce qu'il veut pour la forme et l'emplacement d'une fenetre.
				// Donc meme si l'ecran est dans la bonne resolution, il n'est pas certain que la fenetre soit bien dessine
				// Nous allons donc forcer ce changement
				  printf ("Changement des proprietes de la fenetre.\n");
				  XChangeProperty(dpy, win, prop, prop, 32, PropModeReplace,(unsigned char *) &mwmhints, PROP_MWM_HINTS_ELEMENTS);
				  XMoveWindow (dpy,win, 0, 0); 
			      }
			      printf ("Fenetre creee \n");
			      
			      ctx = glXCreateContext( dpy, vi, 0, GL_TRUE );


			      XFree( fbConfigs ); // Nous n'en avons plus besoin maintenant !
			      fbConfigs = NULL;
			      
			      if ( ! glXIsDirect ( dpy, ctx ) )
			      {
				printf( "Context de rendu GLX indirect.\n" );
			    //   exit(1);
			      }
			      else
				    printf( "Context de rendu GLX direct.\n" );

			      // Utilisons notre nouveau contexte !
//			      printf ("%d %d %d\n",dpy, win, ctx);
			      glXMakeCurrent( dpy, win, ctx );
			      
			      // Positionnement de la souris
			      XWarpPointer(dpy, win, win, 0, 0, 0, 0, width/2 + 1, height/2);
			      if (!initOpenGLGLW(bits))
			      {
				printf ("Echec lors de l'initialisation d'OpenGL !\n");
			      }
			      else
			      {
				// On force l'initialisation des dimensions du viewport
				reSizeSceneGLW(width, height);
				// On force le premier dessin
				onPaintGLW();
			      }

				// On force enfin la disparition du curseur de la souris
				char bm_null[] = { 0,0,0,0, 0,0,0,0,  0,0,0,0,0,0,0,0   ,0,0,0,0, 0,0,0,0,  0,0,0,0,0,0,0,0 }; // Image vide pour le pointeur !
				Pixmap pix_mouse_hide;
				XColor Black;
				// Cr�ation d'un curseur avec cette image vide
				pix_mouse_hide = XCreatePixmapFromBitmapData(dpy, win, bm_null, 16, 16, 1, 0, 1);
				ptr_mouse_hide = XCreatePixmapCursor (dpy, pix_mouse_hide, pix_mouse_hide, &Black, &Black, 1, 1);
				XFreePixmap(dpy, pix_mouse_hide);
				hideMouseGLW(); // Cacher la souris en utilisant le pointeur pr�c�dement cr��.
			  }
			  else
			  {
			      XFree (vi);
			      vi=NULL;
			      
			      XFree( fbConfigs );
			      fbConfigs=NULL;

			      if (fullscreen)
				delete CartGraph;
			      XCloseDisplay(dpy); // Fin de la connexion et au revoir...
			      dpy=NULL;			    
			    return FALSE;
			  }
			}
			else
			{
			  printf ("Echec lors de la connexion au serveur X !\n");
			  return FALSE;
			}
		#endif
	}
	else
		return FALSE;
 }

void GLWindows::destroyWindowGLW(void)
{

	// On r�affiche le curseur de la souris !
	showMouseGLW();
	PosCenter.x = -1;
	PosCenter.y = -1;

	
#ifdef USEGLUT
	if (!bDestroy)
	{
		bDestroy = true;
		if (hWnd)
		{
			// On arr�te toutes nos fonctions, retour aux fonctions standards de GLUT
			glutIdleFunc (NULL);
			glutReshapeFunc (NULL);
			glutKeyboardFunc (NULL);
			glutMotionFunc (NULL);
			glutPassiveMotionFunc (NULL);

			// Eventuellement, revenir � la r�solution �cran d'origine
			if (fullscreen)
			{
				delete CartGraph;
			}

			// Au revoir !
			glutDestroyWindow (hWnd); // Destruction de la fen�tre
			glliste = GLListe::getInstance ();
			glliste->RetireListe(hWnd);
			if (glliste->NbElements() == 0)
				 exit (0); // Plus d'autres fen�tres dans la liste, alors fin de l'application !

			hWnd=NULL;				// hWnd � NULL pour ne pas risquer de le r�utiliser
		}

	}
#else
#ifdef _WIN32

	if (!bDestroy)
	{
		bDestroy = true;
		// Supprimer le contexte rendu
		if (hRC)											
		{
			if (!wglMakeCurrent(NULL,NULL))
			{
				MessageBox(NULL,"Erreur pour r�utiliser le contexte et le rendu par d�faut.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			}

			if (!wglDeleteContext(hRC))
			{
				MessageBox(NULL,"Echec sur la suppression du contexte de rendu.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			}
			hRC=NULL;
		}
	    
		if (hDC && !ReleaseDC(hWnd,hDC))
		{
			MessageBox(NULL,"Echec sur la suppression du contexte de p�riph�rique.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			hDC=NULL;										// Set DC To NULL
		}

		if (hWnd && !DestroyWindow(hWnd))
		{
			MessageBox(NULL,"Impossible de d�truire la fen�tre.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
			hWnd=NULL;										// Set hWnd To NULL
		}

		// Eventuellement, revenir � la r�solution �cran d'origine
		if (fullscreen)
		{
			delete CartGraph;
		}
	}
#else
// On est en mode XWINDOW !
	if (!bDestroy)
	{
		bDestroy = true;
	
		XUndefineCursor(dpy, win); // Remettre le curseur de souris par d�faut
		XFreeCursor (dpy, ptr_mouse_hide); // Plus besoin du curseur de souris cach�
		ptr_mouse_hide = 0;
	
		glXMakeCurrent( dpy, 0, 0 ); // Réinitialisation du contexte
		glXDestroyContext( dpy, ctx );
		if (vi)
		{
		  XFree (vi);
		  vi=NULL;
		}
		
		if (win)
		{
		  XUnmapWindow (dpy, win);
		  XDestroyWindow(dpy,win);
		  win = NULL;
		}
		
		if (fullscreen)
		{
		    delete CartGraph;
		}
		
		if (dpy)
		{
		  XCloseDisplay(dpy); // Fin de la connexion et au revoir...
		  dpy=NULL;
		}
	}
#endif
#endif
	bQuit = true; // On force la sortie du trt des messages
}

bool GLWindows::trtMsgGLW (bool bBcl)
{
    #ifdef USEGLUT
	if (hWnd)
	{
	    glutMainLoop();
	    return false; // Si on est l�, � priori, la fen�tre est d�truite ! 
	}
    #else
      // Code commun à Windows et XWindow
	if (hWnd)
	{
		if (!bBcl && !bQuit)
			readMsgTrtGLW();
		else
		{
			while(!bQuit && bBcl)							// On boucle si bBcl est � vrai et que l'on n'a pas re�u WM_QUIT
			{
				readMsgTrtGLW();
			}
		}
		return bQuit; // Si vrai, fin du programme
	}
	else
		return true;
    #endif
}

#ifndef USEGLUT

// Gestion des messages pour Windows ou XWINDOW
void GLWindows::readMsgTrtGLW()
{
  #ifdef _WIN32	
	MSG		msg;

	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Message � traiter ?
	{
		if (msg.message==WM_QUIT)				// Attention WM_QUIT, indiquer que l'on va sortir de la boucle			
			bQuit=true;
		else
		{
			TranslateMessage(&msg);				// Translate le message
			DispatchMessage(&msg);				// Dispatch le message
		}
	}
	else
	{
		onIdleGLW (); // Temps mort, on peut lancer son propre traitement...
	}
	return;
  #else
	XEvent event;

	if (XPending (dpy) > 0) // Y a-t-il un événement à traiter ? afin de ne pas bloquer
							//  le traitement si aucun événement à traiter
	{
		XNextEvent (dpy, &event); // Lire un événement (avec attente si aucun à traiter !!! 
						// D'où XPending avant !!!
		// On traite l'événement
		WndProcGLW(event);
	}
	else
	{
		onIdleGLW (); // Temps mort, on peut lancer son propre traitement...
	}
  #endif
}

#endif

BOOL GLWindows::initOpenGLGLW(int bits)
{
	//*********************************************************//
	//**** Initialisons OPENGL dans notre nouvelle fenetre ****//
	//*********************************************************//
#ifndef USEGLUT
  #ifdef _WIN32
	int PixelFormat;

	static	PIXELFORMATDESCRIPTOR pfd =
	{ 
	   sizeof(PIXELFORMATDESCRIPTOR), //taille du descripteur de format
	   1, //version
	   PFD_SUPPORT_OPENGL |
	   PFD_DRAW_TO_WINDOW |
	   PFD_DOUBLEBUFFER , // Activer un �cran logique
	   PFD_TYPE_RGBA, //Mode de couleurs RGBA
	   bits, //Bits de couleur
	   0, 0, 0, 0, 0, 0, //Param�tres des couleurs
	   0,0, //Param�tres alpha
	   0,0, 0, 0, 0, //Param�tres du buffer d'accumulation
	   32, //Bits de profondeur
	   0, //Bits du buffer stencil
	   0, //Nombre de buffers auxiliaires
	   0, //ignor� (obsol�te)
	   0, //r�serv�/code>
	   0, //ignor� (obsol�te)
	   0, //Couleur de transparence
	   0 //Ignor� (obsol�te)
	};
	
	// R�cup�ration d'un device context
	if (!(hDC=GetDC(hWnd)))
	{
		destroyWindowGLW();
		MessageBox(NULL,"Erreur la r�cup�ration du Device Context.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		destroyWindowGLW();								// Reset The Display
		MessageBox(NULL,"Impossible de trouver les informations sur le format d'un pixel.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		destroyWindowGLW();								// Reset The Display
		MessageBox(NULL,"Impossible de param�trer le format du pixel.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		destroyWindowGLW();								// Reset The Display
		MessageBox(NULL,"Impossible de cr�er un contexte OpenGL.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		destroyWindowGLW();								// Reset The Display
		MessageBox(NULL,"Impossible d'activer le contexte de rendu OpenGL.","ERREUR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}
  #endif
#endif
	glShadeModel(GL_SMOOTH);				
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);	
	glEnable (GL_COLOR_MATERIAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glClearStencil(0);
        glEnable(GL_CULL_FACE);
	
	glFlush();            

	return TRUE;
}

void GLWindows::setCenterScreenGLW (/*unsigned int uiCenterXScr, unsigned int uiCenterYScr,*/ unsigned int uiCenterX, unsigned int uiCenterY)
{
	PosCenter.x = uiCenterX;
	PosCenter.y = uiCenterY;
}
